using System;
using System.Collections;
using System.Threading;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.IO;

namespace RFIDForm
{


	/// <summary>
	/// Class1 ̊Tv̐łB
	/// </summary>
	public class RFIDForm : System.Windows.Forms.Form
	{
		#region ϐE萔̐錾
		//fobObZ[W\ꍇtrueCȂꍇfalse
		bool Debug = true;

		//COM|[gԍ
		const string DefaultComPort = "COM1";
		//BPSiʏ͕ύXsv)
		const int DefaultBaudRate = 9600;
		//ʐMpobt@TCYiʏ͕ύXsvj
		const int DefaultBufferSize = 80;

		//Aǂݎ莞IDǂݎԊuiP:msec)
		const int DefaultInterval = 200; //0.2b

		//ACeo^pHashtable
		Hashtable itemHolder = new Hashtable();
		//ACeXg̃Xgt@C
		string itemFileName = Application.StartupPath + @"\items.txt";

		//摜t@C̊i[fBNg
		string imageDirectory = Application.StartupPath + @"\image\";

		//ftHgID̔z
		Item [] DefaultItems = {
								   new Item(10000, "ʂ", "ponyo.png"),
								   new Item(10001, "̂ۂۂ", "nopo.png")};
	
			
		//RFIDʐMpNX̐錾
		RFIDComm rfid = null;
		//Mpobt@̐錾
		byte [] txBytes;

		//MpXbh̐錾
		Thread rxThread = null;

		//AvP[V̏
		private enum Modes{Init, Open, Read};
		private Modes mode = Modes.Init;

		//OɔFꂽID
		long lastId = -1;

		//ID菜ꂽꍇɃCxg邩H
		bool removeFlag = true;

		//Cxg̉摜\pNX̐錾
		ImageForm form = null;

		#endregion

		#region RXgN^CfXgN^CȈ
		//RXgN^
		public RFIDForm()
		{
			InitializeComponent();
			rfid = new RFIDComm(DefaultComPort, DefaultBaudRate);
			txBytes = new byte[DefaultBufferSize];

			//ACeo^
			LoadItems();

			Debug = checkBoxDebug.Checked;
			removeFlag = checkBoxRemove.Checked;
			ChangeComponentState(Modes.Init);
		}

		//fXgN^
		~RFIDForm()
		{
		}

		//AvP[VȈ
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			ClosePort();

			if(rxThread != null)
			{
				rxThread.Abort();
			}	
			if(form != null)
			{
				form.Dispose();
			}

			base.Dispose( disposing );
		}
		#endregion


		//IDȍs
		void DealEvent(long id)
		{
			//ID0̏ꍇ͉摜\߂D
			if(id == 0)
			{
				if(form !=null)
					form.Dispose();
			}
			else
			{

				//IDoɍsLqD
				foreach(Item item in itemHolder.Values)
				{
					if(item == null)	break;
			
					if(id == item.id)
					{
						if(form != null) 
							form.Dispose();

						form = new ImageForm(item);
						form.Show();
						form.BringToFront();
						form.Update();
						return;
					}
				}
				//o^ID̏ꍇCtH[J
				if(form != null)
					form.Dispose();
			}
			return;
		}

		#region R|[lg̏
		private void InitializeComponent()
		{
			this.buttonReadStop = new System.Windows.Forms.Button();
			this.buttonReadStart = new System.Windows.Forms.Button();
			this.buttonRead = new System.Windows.Forms.Button();
			this.buttonClose = new System.Windows.Forms.Button();
			this.buttonOpen = new System.Windows.Forms.Button();
			this.textBoxMessage = new System.Windows.Forms.TextBox();
			this.comboBoxPort = new System.Windows.Forms.ComboBox();
			this.labelId = new System.Windows.Forms.Label();
			this.textBoxId = new System.Windows.Forms.TextBox();
			this.labelProgram = new System.Windows.Forms.Label();
			this.textBoxProgram = new System.Windows.Forms.TextBox();
			this.buttonProgram = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.checkBoxRemove = new System.Windows.Forms.CheckBox();
			this.checkBoxDebug = new System.Windows.Forms.CheckBox();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.SuspendLayout();
			// 
			// buttonReadStop
			// 
			this.buttonReadStop.Enabled = false;
			this.buttonReadStop.Location = new System.Drawing.Point(208, 48);
			this.buttonReadStop.Name = "buttonReadStop";
			this.buttonReadStop.Size = new System.Drawing.Size(88, 23);
			this.buttonReadStop.TabIndex = 6;
			this.buttonReadStop.Text = "Aǎ~";
			this.buttonReadStop.Click += new System.EventHandler(this.buttonReadStop_Click);
			// 
			// buttonReadStart
			// 
			this.buttonReadStart.Enabled = false;
			this.buttonReadStart.Location = new System.Drawing.Point(112, 48);
			this.buttonReadStart.Name = "buttonReadStart";
			this.buttonReadStart.Size = new System.Drawing.Size(88, 23);
			this.buttonReadStart.TabIndex = 5;
			this.buttonReadStart.Text = "AǎJn";
			this.buttonReadStart.Click += new System.EventHandler(this.buttonReadStart_Click);
			// 
			// buttonRead
			// 
			this.buttonRead.Enabled = false;
			this.buttonRead.Location = new System.Drawing.Point(24, 48);
			this.buttonRead.Name = "buttonRead";
			this.buttonRead.TabIndex = 4;
			this.buttonRead.Text = "ǎ";
			this.buttonRead.Click += new System.EventHandler(this.buttonRead_Click);
			// 
			// buttonClose
			// 
			this.buttonClose.Enabled = false;
			this.buttonClose.Location = new System.Drawing.Point(216, 16);
			this.buttonClose.Name = "buttonClose";
			this.buttonClose.TabIndex = 3;
			this.buttonClose.Text = "ؒf";
			this.buttonClose.Click += new System.EventHandler(this.buttonClose_Click);
			// 
			// buttonOpen
			// 
			this.buttonOpen.Location = new System.Drawing.Point(24, 16);
			this.buttonOpen.Name = "buttonOpen";
			this.buttonOpen.TabIndex = 1;
			this.buttonOpen.Text = "ڑ";
			this.buttonOpen.Click += new System.EventHandler(this.buttonOpen_Click);
			// 
			// textBoxMessage
			// 
			this.textBoxMessage.Location = new System.Drawing.Point(8, 88);
			this.textBoxMessage.Multiline = true;
			this.textBoxMessage.Name = "textBoxMessage";
			this.textBoxMessage.ReadOnly = true;
			this.textBoxMessage.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxMessage.Size = new System.Drawing.Size(360, 184);
			this.textBoxMessage.TabIndex = 8;
			this.textBoxMessage.Text = "";
			// 
			// comboBoxPort
			// 
			this.comboBoxPort.Items.AddRange(new object[] {
															  "COM1",
															  "COM2",
															  "COM3",
															  "COM4",
															  "COM5",
															  "COM6",
															  "COM7",
															  "COM8",
															  "COM9",
															  "COM10",
															  "COM11",
															  "COM12",
															  "COM13",
															  "COM14",
															  "COM15",
															  "COM16",
															  "COM17",
															  "COM18",
															  "COM19",
															  "COM20"});
			this.comboBoxPort.Location = new System.Drawing.Point(112, 16);
			this.comboBoxPort.Name = "comboBoxPort";
			this.comboBoxPort.Size = new System.Drawing.Size(88, 20);
			this.comboBoxPort.TabIndex = 2;
			this.comboBoxPort.Text = "COM1";
			this.comboBoxPort.SelectedIndexChanged += new System.EventHandler(this.comboBoxPort_SelectedIndexChanged);
			// 
			// labelId
			// 
			this.labelId.Location = new System.Drawing.Point(8, 24);
			this.labelId.Name = "labelId";
			this.labelId.Size = new System.Drawing.Size(56, 16);
			this.labelId.TabIndex = 16;
			this.labelId.Text = "^OID";
			// 
			// textBoxId
			// 
			this.textBoxId.Location = new System.Drawing.Point(8, 48);
			this.textBoxId.Name = "textBoxId";
			this.textBoxId.ReadOnly = true;
			this.textBoxId.Size = new System.Drawing.Size(152, 19);
			this.textBoxId.TabIndex = 7;
			this.textBoxId.Text = "";
			// 
			// labelProgram
			// 
			this.labelProgram.Location = new System.Drawing.Point(8, 88);
			this.labelProgram.Name = "labelProgram";
			this.labelProgram.Size = new System.Drawing.Size(120, 16);
			this.labelProgram.TabIndex = 18;
			this.labelProgram.Text = "^OIDiݗpj";
			// 
			// textBoxProgram
			// 
			this.textBoxProgram.Location = new System.Drawing.Point(8, 112);
			this.textBoxProgram.Name = "textBoxProgram";
			this.textBoxProgram.Size = new System.Drawing.Size(152, 19);
			this.textBoxProgram.TabIndex = 8;
			this.textBoxProgram.Text = "";
			// 
			// buttonProgram
			// 
			this.buttonProgram.Enabled = false;
			this.buttonProgram.Location = new System.Drawing.Point(48, 136);
			this.buttonProgram.Name = "buttonProgram";
			this.buttonProgram.TabIndex = 9;
			this.buttonProgram.Text = "";
			this.buttonProgram.Click += new System.EventHandler(this.buttonProgram_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.buttonReadStop,
																					this.buttonRead,
																					this.comboBoxPort,
																					this.buttonClose,
																					this.buttonReadStart,
																					this.buttonOpen});
			this.groupBox1.Location = new System.Drawing.Point(16, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(320, 80);
			this.groupBox1.TabIndex = 20;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "R}h";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.textBoxId,
																					this.buttonProgram,
																					this.labelId,
																					this.textBoxProgram,
																					this.labelProgram});
			this.groupBox2.Location = new System.Drawing.Point(392, 8);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(176, 168);
			this.groupBox2.TabIndex = 21;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "ID";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.checkBoxRemove,
																					this.checkBoxDebug});
			this.groupBox3.Location = new System.Drawing.Point(376, 192);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(192, 80);
			this.groupBox3.TabIndex = 22;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "ݒ";
			// 
			// checkBoxRemove
			// 
			this.checkBoxRemove.Checked = true;
			this.checkBoxRemove.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxRemove.Location = new System.Drawing.Point(8, 48);
			this.checkBoxRemove.Name = "checkBoxRemove";
			this.checkBoxRemove.Size = new System.Drawing.Size(192, 24);
			this.checkBoxRemove.TabIndex = 11;
			this.checkBoxRemove.Text = "菜o";
			this.checkBoxRemove.CheckedChanged += new System.EventHandler(this.checkBoxRemove_CheckedChanged);
			// 
			// checkBoxDebug
			// 
			this.checkBoxDebug.Location = new System.Drawing.Point(8, 16);
			this.checkBoxDebug.Name = "checkBoxDebug";
			this.checkBoxDebug.Size = new System.Drawing.Size(168, 24);
			this.checkBoxDebug.TabIndex = 10;
			this.checkBoxDebug.Text = "fobObZ[W\";
			this.checkBoxDebug.CheckedChanged += new System.EventHandler(this.checkBoxDebug_CheckedChanged);
			// 
			// RFIDForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(568, 278);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.groupBox3,
																		  this.textBoxMessage,
																		  this.groupBox1,
																		  this.groupBox2});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "RFIDForm";
			this.Text = "RFIDeXgptH[";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		#region R|[lg̐錾
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button buttonReadStop;
		private System.Windows.Forms.Button buttonReadStart;
		private System.Windows.Forms.Button buttonRead;
		private System.Windows.Forms.Button buttonClose;
		private System.Windows.Forms.Button buttonOpen;
		private System.Windows.Forms.ComboBox comboBoxPort;
		private System.Windows.Forms.Label labelId;
		private System.Windows.Forms.TextBox textBoxId;
		private System.Windows.Forms.Label labelProgram;
		private System.Windows.Forms.TextBox textBoxProgram;
		private System.Windows.Forms.Button buttonProgram;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TextBox textBoxMessage;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.CheckBox checkBoxDebug;
		private System.Windows.Forms.CheckBox checkBoxRemove;
		#endregion


		#region R|[lg̃Cxg
		private void buttonOpen_Click(object sender, System.EventArgs e)
		{
			OpenPort();	
		}

		private void buttonRead_Click(object sender, System.EventArgs e)
		{
			SendCommand(IdTx.Read);
		}

		private void buttonReadStart_Click(object sender, System.EventArgs e)
		{
			SendCommand(IdTx.ReadLine);
		}

		private void buttonClose_Click(object sender, System.EventArgs e)
		{
			ClosePort();
		}

		private void buttonReadStop_Click(object sender, System.EventArgs e)
		{
			SendCommand(IdTx.Read);
		}

		private void buttonProgram_Click(object sender, System.EventArgs e)
		{
			byte [] data = new byte[8];
			if(GetProgrammingId(ref data))
			{
				SendCommand(IdTx.Program,data);
				Thread.Sleep(100);
				SendCommand(IdTx.Read);
			}
		}

		private void checkBoxDebug_CheckedChanged(object sender, System.EventArgs e)
		{
			Debug = checkBoxDebug.Checked;
		}

		private void checkBoxRemove_CheckedChanged(object sender, System.EventArgs e)
		{
			removeFlag = checkBoxRemove.Checked;
		}

		private void comboBoxPort_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			rfid.Port = (string)comboBoxPort.SelectedItem;
		}

		#endregion


		#region Utilityñ\bh
		
		//NIDƃL[[h̃Xg擾
		void LoadItems()
		{
			if(!File.Exists(itemFileName))
			{
				//ftHg̃ACeo^
				foreach(Item item in DefaultItems)
				{
					item.url = imageDirectory + item.url;
					itemHolder.Add(item.id, item);
				}
				return;	
			}
			else
			{
				StreamReader reader = new StreamReader(itemFileName,System.Text.Encoding.Default);
				try
				{
					while(true)
					{
						string line = reader.ReadLine();
						if(line == null) break;
						
						if(line.StartsWith("//")) continue;

						string [] data = line.Split('\t');
						if(data.Length<3)continue;


						long id = long.Parse((string)data[0]);
						string name = (string)data[1];
						string url = (string)data[2];
						itemHolder.Add(id, new Item(id, name, imageDirectory + url));
					}
				}
				catch(Exception ex)
				{
					PrintError("ACe̓ǂݍݎɃG[N܂D");
					PrintError(ex.Message);
				}
	
				reader.Close();
			}
		}

		private void PrintMessage(string m, params object []args)
		{
			
			string message = String.Format(m, args);
			//Console.WriteLine(message);
			textBoxMessage.Text = message + "\r\n" + textBoxMessage.Text;
		}

		private void PrintDebug(string m, params object []args)
		{
			if(Debug)
			{
				PrintMessage(m,args);
			}
		}

		private void PrintError(string m, params object []args)
		{
			PrintMessage("Error: " + m, args);
		}

		private string GetMessage()
		{
			//return Console.ReadLine();
			return "";
		}


		//oCgz񂩂CŌNUL菜
		private byte[] ChopBytes(byte [] bytes)
		{
			int cnt=0;
			byte [] choppedBytes;
			for(int i= bytes.Length;i>0;i--)
			{
				if(bytes[i-1] == 0x00)
				{
					cnt ++;
				}
				else
				{
					break;
				}
			}

			choppedBytes = new byte [bytes.Length - cnt];
			Array.Copy(bytes,0,choppedBytes,0,bytes.Length - cnt);
			
			return choppedBytes;
		}

		//R|[lg̏Ԃς
		private void ChangeComponentState(Modes m)
		{
			mode = m;
			switch(mode)
			{
				case Modes.Init:
					buttonClose.Enabled = false;
					buttonOpen.Enabled = true;
					buttonProgram.Enabled = false;
					buttonRead.Enabled =false;
					buttonReadStart.Enabled = false;
					buttonReadStop.Enabled = false;
					comboBoxPort.Enabled = true;
					textBoxProgram.Enabled = false;
					break;

				case Modes.Open:
					buttonClose.Enabled = true;
					buttonOpen.Enabled = false;
					buttonProgram.Enabled = true;
					buttonRead.Enabled =true;
					buttonReadStart.Enabled = true;
					buttonReadStop.Enabled = false;
					comboBoxPort.Enabled = false;
					textBoxProgram.Enabled = true;
					break;

				case Modes.Read:
					buttonClose.Enabled = true;
					buttonOpen.Enabled = false;
					buttonProgram.Enabled = false;
					buttonRead.Enabled =true;
					buttonReadStart.Enabled = false;
					buttonReadStop.Enabled = true;
					comboBoxPort.Enabled = false;
					textBoxProgram.Enabled = false;
		
					break;
			}
			return;
		}

		#endregion


		#region RFIDCommNXpRFID[_[Ƃ̒ʐM\bh
		//COM|[gJ
		void OpenPort()
		{
			if(rfid.IsOpen)
			{
				PrintMessage("{0}|[g͊ɃI[vĂ܂D", rfid.Port);
			}
			else
			{
				if(rfid.Open())
				{
					PrintMessage("{0}|[gI[v܂D", rfid.Port);
					if(rxThread == null)
					{
						rxThread = new Thread(new ThreadStart(ReadIdWorker));
						rxThread.Start();
					}
					ChangeComponentState(Modes.Open);
				}
				else
				{
					PrintError("{0}|[g̃I[vɎs܂D", rfid.Port);
				}
			}
		}

		//COM|[g
		void ClosePort()
		{
			if(rfid.IsOpen)
			{
				SendCommand(IdTx.Read);
				rfid.Close();
				if(rxThread != null && rxThread.IsAlive)
				{
					rxThread.Abort();
					rxThread = null;
				}
				PrintMessage("{0}|[gN[Y܂D", rfid.Port);
				ChangeComponentState(Modes.Init);
			}
			else
			{
				PrintError("{0}|[g͊JĂ܂D", rfid.Port);
			}
			return;
		}


		//ݗpID擾
		bool GetProgrammingId(ref byte [] data)
		{
			string line;
			long num;

			line = textBoxProgram.Text;

			if(line == "")
			{
				PrintMessage("IDύXɏI܂D"); 
				return false;
			}
						
			try
			{
				num = Int64.Parse(line);
			}
			catch(System.FormatException e)
			{
				PrintError("IDlł͂܂D\r\n" +
					"	[0 - 18446744073709551615]̊Ԃ̐͂ĂD\r\n" +
					"	IDύXɏI܂D");

				return false;
			}

			data = BitConverter.GetBytes(num);

			return true;
		}

		//ǂݎCAǂݎ̃R}h𑗂
		void SendCommand(IdTx id)
		{
			byte []data = new byte[1];
			SendCommand(id, data);
			return;
		}

		//(ǂݎCAǂݎ)C݂̃R}h𑗂
		void SendCommand(IdTx idType, byte [] data)
		{
			if(!(rfid.IsOpen))
			{
				PrintError("{0}|[g̓I[vĂ܂D", rfid.Port);
				return;
			}

			if(rfid.SendMessage(idType, data, ref txBytes))
			{
				PrintDebug("RFID[_ɃbZ[W𑗐M܂[{0}]",BitConverter.ToString(txBytes));
				if(idType == IdTx.ReadLine)
				{
					ChangeComponentState(Modes.Read);
				}
				else 
				{
					ChangeComponentState(Modes.Open);
				}
			}
			else
			{
				PrintError("RFID[_ւ̃bZ[W̑MɎs܂[{0}]",BitConverter.ToString(txBytes));
			}	
		}


		//AǂݎpXbh
		void ReadIdWorker()
		{
			byte [] rxBytes = new byte[DefaultBufferSize];

			RFIDDataRx dataRx;
			dataRx = new RFIDDataRx();

			while(true)
			{
				if(!rfid.IsOpen)
				{
					PrintError("|[gJ܂DǂݎXbhI܂D");
					break;
				}

				if(rfid.ReceiveMessage(ref rxBytes, ref dataRx))
				{	
					if(dataRx.id == RFIDComm.RX_ID_OTHER_READ)
					{
						PrintDebug("Received Bytes:{0}",BitConverter.ToString(ChopBytes(rxBytes)));
						//if(lastId != -1)
						//{
						//textBoxId.Text = "Error";
						//DealEvent(0);
						//	lastId = -1;
						//}
					}
					else if (dataRx.id == RFIDComm.RX_ID_NO_READ)
					{
						
						PrintDebug("No Read");
						if(lastId != 0)
						{
							if(removeFlag)
							{
								textBoxId.Text = "No Read";
								DealEvent(0);
								lastId = 0;
							}
						}
					}
					else
					{
						string typeStr;
						switch (dataRx.type)
						{
							case RFIDComm.RX_TYPE_RO:
								typeStr = "Read Only";
								break;
							case RFIDComm.RX_TYPE_RW:
								typeStr = "Read/Write";
								break;
							case RFIDComm.RX_TYPE_MPT:
								typeStr = "MPT";
								break;
							default:
								typeStr = "Other";
								break;
						}

						PrintDebug("Succeed:^O^Cv[{0}], ^OID[{1}]",typeStr, dataRx.id);
						if(dataRx.id != lastId)
						{
							textBoxId.Text = dataRx.id.ToString();
							DealEvent(dataRx.id);
							lastId = dataRx.id;
						}
						
					}
				}
				else
				{
					//PrintError("|[gJ܂DǂݎXbhI܂D");
					//break;
				}
				Thread.Sleep(200);
			}
			return;
		}		
		#endregion



		[STAThread]
		static void Main(string[] args)
		{
			Application.Run(new RFIDForm());
		}

	}
}
